/*
 * Copyright 2011 Red Hat, Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *    1. Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *
 *    2. Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in
 *       the documentation and/or other materials provided with the
 *       distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef CODEC_H_
#define CODEC_H_

#include "asn1/asn_application.h"
#include <stdbool.h>

#define int_ber_decode(type, buf, len) \
  ((type ## _t*) int_ber_decode_(&asn_DEF_ ## type, buf, len))
void *
int_ber_decode_(asn_TYPE_descriptor_t *type_descriptor, const char *buf,
                int len);

bool
int_der_encode(asn_TYPE_descriptor_t *type_descriptor, void *ptr, char **buf,
               unsigned int *len);

#define int_uper_decode(type, buf, len, skip, unused) \
  ((type ## _t*) int_uper_decode_(&asn_DEF_ ## type, buf, len, skip, unused))
void *
int_uper_decode_(asn_TYPE_descriptor_t *type_descriptor, const char *buf,
                 int len, int skip_bits, int unused_bits);

bool
int_uper_encode(asn_TYPE_descriptor_t *type_descriptor, void *ptr, char **buf,
                unsigned int *len);

#define int_xer_decode(type, buf, len) \
  ((type ## _t*) int_xer_decode_(&asn_DEF_ ## type, buf, len))
void *
int_xer_decode_(asn_TYPE_descriptor_t *type_descriptor, const char *buf,
                int len);

bool
int_xer_encode(asn_TYPE_descriptor_t *type_descriptor, void *ptr,
               enum xer_encoder_flags_e xer_flags, char **buf,
               unsigned int *len);

#endif /* CODEC_H_ */
